exec("./support_client.cs");

$BaseRaiders::Client::Version = "2.1";

function clientCmdBaseRaiders_recieveMyScore(%num)
{
	if(!isNumber(%num))
	{
		$BaseRaiders::Client::MyScore = 0;
	}

	else
	{
		$BaseRaiders::Client::MyScore = %num;
	}

	if(BaseRaiders_BuyItemGui.isVisible() && BaseRaiders_BuyItemGui_Items.getText() !$= "" && BaseRaiders_BuyItemGui_Items.getText() !$= "NONE")
	{
		%itemCost = strReplace(getWord(stripMLControlChars(BaseRaiders_BuyItemGui_Cost.getText()), 1), "$", "");
		%color = $BaseRaiders::Client::MyScore < %itemCost ? "<color:ff0000>" : "<color:00bb00>";

		BaseRaiders_BuyItemGui_Cost.setText("<just:center><font:impact:18>Cost:" SPC %color @ "$" @ %itemCost);
	}

	if(BaseRaiders_ItemPriceGui.isVisible() && Wrench_Items.getText() !$= "" && Wrench_Items.getText() !$= "NONE")
	{
		%itemCost = strReplace(getWord(stripMLControlChars(BaseRaiders_ItemPriceGui.getText()), 1), "$", "");
		%color = $BaseRaiders::Client::MyScore < %itemCost ? "<color:ff0000>" : "<color:00bb00>";

		BaseRaiders_ItemPriceGui.setText("<just:center><font:impact:18>Cost:" SPC %color @ "$" @ %itemCost);
	}

	if(BaseRaiders_BrickStatsGui.isVisible() && BaseRaiders_BrickStatsGui.getCount() > 5)
	{
		%count = BaseRaiders_BrickStatsGui.getCount();

		for(%i = 5; %i < %count; %i++)
		{
			%obj = BaseRaiders_BrickStatsGui.getObject(%i);

			if(%obj.getClassName() !$= "GuiMLTextCtrl")
			{
				continue;
			}

			%text = stripMLControlChars(strReplace(%obj.getText(), "<just:right>", " "));
			%brickCost = strReplace(getWord(%text, 1), "$", "");

			if(firstWord(%text) $= "Cost:")
			{
				%color = $BaseRaiders::Client::MyScore < %brickCost ? "<color:ff0000>" : "<color:00bb00>";

				%obj.setText("<font:impact:20><color:eeee00>Cost<color:000000>:<just:right>" @ %color @ "$" @ %brickCost);
			}
		}
	}
}

function clientCmdBaseRaiders_Handshake()
{
	$BaseRaiders::Client::IsOnServer = true;

	commandToServer('baseRaiders_Handshake', $BaseRaiders::Client::Version);
}

exec("./buyItemGui.gui");

if(!isObject(BaseRaiders_ItemPriceGui))
{
	new GuiMLTextCtrl(BaseRaiders_ItemPriceGui)
	{
		profile = "GuiMLTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "32 128";
		extent = "250 18";
		minExtent = "8 2";
		enabled = 1;
		visible = 0;
		clipToParent = 1;
		lineSpacing = 2;
		allowColorChars = 1;
		maxChars = -1;
		text = "<just:center><font:impact:18><color:00bb00>Cost: $0";
		maxBitmapHeight = -1;
		selectable = 0;
		autoResize = 1;
	};

	Wrench_Window.add(BaseRaiders_ItemPriceGui);
}

Wrench_Items.command = Wrench_Items.command @ "Wrench_Items.BaseRaiders_requestItemPrice();";

function clientCmdBaseRaiders_openBuyItemGUI()
{
	canvas.pushDialog(BaseRaiders_BuyItemGui);
	canvas.popDialog(wrenchDlg);
}

function Wrench_Items::BaseRaiders_requestItemPrice(%obj)
{
	%text = %obj.getText();

	BaseRaiders_ItemPriceGui.setVisible(0);

	if(%text $= "" || %text $= " NONE")
	{
		return;
	}

	commandToServer('BaseRaiders_getItemPrice', %text);
}

function clientCmdBaseRaiders_recieveItemPrice(%num, %cannotAfford)
{
	%num = minClamp(%num, -1);
	%num = %num >= 0 ? "$" @ %num : "RESTRICTED";
	%color = %cannotAfford ? "<color:ff0000>" : "<color:00bb00>";

	BaseRaiders_BuyItemGui_Cost.setText("<just:center><font:impact:18>Cost:" @ %color SPC %num);
	BaseRaiders_ItemPriceGui.setText("<just:center><font:impact:18>Cost:" @ %color SPC %num);
	BaseRaiders_BuyItemGui_Cost.setVisible(1);
	BaseRaiders_ItemPriceGui.setVisible(1);
}

exec("./brickStatsGui.gui");

function clientCmdBaseRaiders_recieveBrickBuyInfo(%info)
{
	BaseRaiders_BrickStatsGui_Preview.getObject(0).mColor = "255 255 255 255";

	BaseRaiders_BrickStatsGui.deleteJunk();

	if(%info $= "-1")
	{
		return;
	}

	%count = getFieldCount(%info);

	for(%i = 0; %i < %count; %i++)
	{
		%field = getField(%info, %i);
		%field = stripMLControlChars(%field);
		%field = strReplace(%field, "|", "\t");
		%var = getField(%field, 0);
		%value = getField(%field, 1);

		switch$(%var)
		{
			case "uiName":
				BaseRaiders_BrickStatsGui_Preview.getObject(1).setText(%value);
				%offset++;
				continue;

			case "Color":
				BaseRaiders_BrickStatsGui_Preview.getObject(0).setColor(%value);
				%offset++;
				continue;

			case "Cost":
				%var = "\c3" @ %var;
				%value = minClamp(%value, -1);

				if(%value == -1)
				{
					%value = "\c0RESTRICTED";
				}

				else 
				{
					%value = $BaseRaiders::Client::MyScore !$= "" && $BaseRaiders::Client::MyScore >= %value ? "<color:00bb00>$" @ %value : "\c0$" @ %value;
				}

			case "Strength Multiplier":
				%var = "\c7" @ %var;
				%value = minClamp(%value, 1);
				%value = "\c7" @ %value;

			case "Power":
				%var = "\c3" @ %var;
				%value = minClamp(%value, 0);
				%value = "\c3" @ %value;

			case "Power Drain Time":
				%var = "\c0" @ %var;
				%value = minClamp(%value, 0);
				%value = "\c0" @ %value;

			case "Print Time":
				%var = "\c1" @ %var;
				%value = minClamp(%value, 0);
				%value = "\c1" @ %value;

			case "Storage Space":
				%var = "<color:aa6600>" @ %var;
				%value = minClamp(%value, 0);
				%value = "<color:aa6600>" @ %value;

			default:
				%offset++;
				continue;
		}

		// \c0 - Red
		// \c1 - Blue
		// \c2 - Green
		// \c3 - Yellow
		// \c4 - Cyan
		// \c5 - Pink
		// \c6 - White
		// \c7 - Grey
		// \c8 & \c9 - Black

		%var = strReplace(%var, "\c0", "<color:ff0000>");
		%var = strReplace(%var, "\c1", "<color:0000ff>");
		%var = strReplace(%var, "\c2", "<color:00dd00>");
		%var = strReplace(%var, "\c3", "<color:eeee00>");
		%var = strReplace(%var, "\c4", "<color:00ffff>");
		%var = strReplace(%var, "\c5", "<color:ff00ff>");
		%var = strReplace(%var, "\c6", "<color:ffffff>");
		%var = strReplace(%var, "\c7", "<color:777777>");
		%var = strReplace(%var, "\c8", "<color:000000>");
		%var = strReplace(%var, "\c9", "<color:000000>");

		%value = strReplace(%value, "\c0", "<color:ff0000>");
		%value = strReplace(%value, "\c1", "<color:0000ff>");
		%value = strReplace(%value, "\c2", "<color:00dd00>");
		%value = strReplace(%value, "\c3", "<color:eeee00>");
		%value = strReplace(%value, "\c4", "<color:00ffff>");
		%value = strReplace(%value, "\c5", "<color:ff00ff>");
		%value = strReplace(%value, "\c6", "<color:ffffff>");
		%value = strReplace(%value, "\c7", "<color:777777>");
		%value = strReplace(%value, "\c8", "<color:000000>");
		%value = strReplace(%value, "\c9", "<color:000000>");

		%obj = new GuiMLTextCtrl()
		{
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20" SPC 150 + (31 * (%i - %offset));
			extent = "152 22";
			minExtent = "8 22";
			enabled = 1;
			visible = 1;
			clipToParent = 1;
			lineSpacing = 2;
			allowColorChars = 1;
			maxChars = -1;
			text = "<font:impact:20>" @ %var @ "<color:000000>:<just:right>" @ %value;
			maxBitmapHeight = -1;
			selectable = 0;
			autoResize = 0;
		};

		BaseRaiders_BrickStatsGui.add(%obj);
	}

	if(!BaseRaiders_BrickStatsGui.isVisible())
	{
		BSD_Window.setExtent(firstWord(BSD_Window.getExtent()) + 192 SPC getWord(BSD_Window.getExtent(), 1));
	}

	BaseRaiders_BrickStatsGui.setVisible(1);
}

package BaseRaiders_Client
{
	function BSD_ClickIcon(%data)
	{
		parent::BSD_ClickIcon(%data);

		%currCategory = BSD_ScrollBox.getObject($BSD_SelectedTab).getObject(0);

		for(%i = 0; %i < %currCategory.getCount(); %i++)
		{
			%obj = %currCategory.getObject(%i);

			if(%obj.getClassName() $= "GuiBitmapButtonCtrl" && getSubStr(%obj.command, 0, 13) $= "BSD_ClickIcon")
			{
				%objData = getSubStr(%obj.command, strStr(%obj.command, "(") + 1, strStr(%obj.command, ")") - strStr(%obj.command, "(") - 1);

				if(%objData $= %data)
				{
					%background = %currCategory.getObject(%i - 3);
					%icon = %currCategory.getObject(%i - 2);
					%activeOverlay = %currCategory.getObject(%i - 1);
					%button = %obj;
					%text = %currCategory.getObject(%i + 1);

					%buttonCount = %i;

					break;
				}
			}
		}

		if(!isObject(%background) || !isObject(%icon) || !isObject(%activeOverlay) || !isObject(%button) || !isObject(%text))
		{
			return;
		}

		if(%data $= $BaseRaiders::Client::LastBrickStats)
		{
			return;
		}

		$BaseRaiders::Client::LastBrickStats = %data;

		if(BaseRaiders_BrickStatsGui.isVisible())
		{
			BSD_Window.setExtent(firstWord(BSD_Window.getExtent()) - 192 SPC getWord(BSD_Window.getExtent(), 1));
		}

		BaseRaiders_BrickStatsGui.setVisible(0);
		BaseRaiders_BrickStatsGui.deleteJunk();

		BaseRaiders_BrickStatsGui_Preview.getObject(0).setBitmap(%icon.bitmap);

		commandToServer('BaseRaiders_getBrickBuyInfo', %data);
	}

	function brickSelectorDlg::onSleep(%gui)
	{
		parent::onSleep(%gui);

		$BaseRaiders::Client::LastBrickStats = "";

		if(BaseRaiders_BrickStatsGui.isVisible())
		{
			BSD_Window.setExtent(firstWord(BSD_Window.getExtent()) - 192 SPC getWord(BSD_Window.getExtent(), 1));
			BaseRaiders_BrickStatsGui.setVisible(0);
			BaseRaiders_BrickStatsGui.deleteJunk();

			BaseRaiders_BrickStatsGui_Preview.getObject(0).setBitmap("base/client/ui/brickicons/Unknown");
		}
	}

	function disconnect(%rejoin)
	{
		BaseRaiders_ItemPriceGui.setVisible(0);

		if(BaseRaiders_BrickStatsGui.isVisible())
		{
			BSD_Window.setExtent(firstWord(BSD_Window.getExtent()) - 192 SPC getWord(BSD_Window.getExtent(), 1));
		}

		BaseRaiders_BrickStatsGui.setVisible(0);
		BaseRaiders_BrickStatsGui.deleteJunk();

		$BaseRaiders::Client::IsOnServer = false;
		$BaseRaiders::Client::LastBrickStats = false;

		return parent::disconnect(%rejoin);
	}
};
activatePackage(BaseRaiders_Client);